import bulbEmpty from 'assets/icons/visu/bulbEmpty.svg'
import bulbFilled from 'assets/icons/visu/bulbFilled.svg'
import classNames from 'classnames'
import StyledIcon from 'components/CommonKit/Icon/StyledIcon'
import React from 'react'

const EfficiencyRating = ({
  result,
  iconSize = 16,
}: {
  result: number
  iconSize?: number
}) => {
  const maxStars = [1, 2, 3, 4, 5]

  return (
    <div>
      {maxStars.map(star => {
        const isFilled = result >= star
        return (
          <StyledIcon
            key={star}
            className={classNames(`star`, { glow: isFilled })}
            icon={isFilled ? bulbFilled : bulbEmpty}
            size={iconSize}
          />
        )
      })}
    </div>
  )
}

export default EfficiencyRating
