import { FluidState, FluidType } from 'enums'
import { DateTime } from 'luxon'
import { Account, Konnector, KonnectorConfig, Trigger } from 'models'
import { TriggerState } from './trigger.model'

export interface FluidStatus {
  fluidType: FluidType
  status: FluidState
  maintenance: boolean
  firstDataDate: DateTime | null
  lastDataDate: DateTime | null
  connection: FluidConnection
}

export interface FluidConnection {
  /** This toggles the launch of the konnector when set to true */
  shouldLaunchKonnector: boolean
  /** When enabled, alters the texts of Konnector Modal */
  isUpdating: boolean
  konnector: Konnector | null
  account: Account | null
  trigger: Trigger | null
  triggerState: TriggerState | null
  konnectorConfig: KonnectorConfig
}
